## codec2 1.1.1

=== CMakeLists.txt ===
#
# Codec2 - Next-Generation Digital Voice for Two-Way Radio
#
# CMake configuration contributed by Richard Shaw (KF5OIM)
# Please report questions, comments, problems, or patches to the freetel
# mailing list: https://lists.sourceforge.net/lists/listinfo/freetel-codec2
#

# Note: this has to be at the beginning of the file in order for CMake to 
# actually recognize this override (vs. simply telling the macOS build toolchain
# to mandate the current release).
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

cmake_minimum_required(VERSION 3.13)
project(CODEC2
  VERSION 1.1.1
  DESCRIPTION "Next-Generation Digital Voice for Two-Way Radio"
  HOMEPAGE_URL "https://www.rowetel.com/codec2.html"
  LANGUAGES C
  )

include(GNUInstallDirs)
mark_as_advanced(CLEAR
    CMAKE_INSTALL_BINDIR
    CMAKE_INSTALL_INCLUDEDIR
    CMAKE_INSTALL_LIBDIR
)

#
# Prevent in-source builds
# If an in-source build is attempted, you will still need to clean up a few
# files manually.
#
set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds in ${CMAKE_BINARY_DIR} are not "
   "allowed, please remove ./CMakeCache.txt and ./CMakeFiles/, create a "
   "separate build directory and run cmake from there.")
endif("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")

# Set default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Debug")
endif()

# Build universal ARM64 and x86_64 binaries on Mac.
if(BUILD_OSX_UNIVERSAL)
set(CMAKE_OSX_ARCHITECTURES "x86_64;arm64")
endif(BUILD_OSX_UNIVERSAL)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

#
# Find the git hash if this is a working copy.
#
if(EXISTS ${CMAKE_SOURCE_DIR}/.git)
    find_package(Git)
    if(Git_FOUND)
        execute_process(
            COMMAND "${GIT_EXECUTABLE}" rev-parse --short HEAD
            WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
            RESULT_VARIABLE res
            OUTPUT_VARIABLE CODEC2_HASH
            ERROR_QUIET
            OUTPUT_STRIP_TRAILING_WHITESPACE)
        message(STATUS "Codec2 current git hash: ${CODEC2_HASH}")
        add_definitions(-DGIT_HASH="${CODEC2_HASH}")
    else()
        message(WARNING "Git not found. Can not determine current commit hash.")
        add_definitions(-DGIT_HASH="Unknown")
    endif()
else()
        add_definitions(-DGIT_HASH="None")
endif()

set(ARCHIVE_NAME "codec2-${CODEC2_VERSION_MAJOR}.${CODEC2_VERSION_MINOR}.${CODEC2_VERSION_PATCH}")
add_custom_target(dist
    COMMAND git archive --prefix=${ARCHIVE_NAME}/ HEAD
        | bzip2 > ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

# Set default C flags.
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wno-strict-overflow")

# Check for what C standard is supported.
if(NOT WIN32)
include(CheckCCompilerFlag)
CHECK_C_COMPILER_FLAG("-std=gnu11" COMPILER_SUPPORTS_GNU11)
CHECK_C_COMPILER_FLAG("-std=gnu99" COMPILER_SUPPORTS_GNU99)

if(COMPILER_SUPPORTS_GNU11)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu11")
elseif(COMPILER_SUPPORTS_GNU99)
   set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
else()
   message(SEND_ERROR "Compiler doesn't seem to support at least gnu99, might cause problems" )
endif()
endif(NOT WIN32)

# -fPIC is implied on MinGW...
if((NOT WIN32) AND (NOT MICROCONTROLLER_BUILD))
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
endif()

set(CMAKE_C_FLAGS_DEBUG "-g -O2 -DDUMP")
set(CMAKE_C_FLAGS_RELEASE "-O3")

#
# Setup Windows/MinGW specifics here.
#
if(MINGW)
    message(STATUS "System is MinGW.")
endif(MINGW)

#
# Default options
#
option(BUILD_SHARED_LIBS
    "Build shared library. Set to OFF for static library." ON)
option(UNITTEST "Build unittest binaries." OFF)
option(INSTALL_EXAMPLES "Install example code." OFF)
if(INSTALL_EXAMPLES)
    install(DIRECTORY octave raw script wav
        USE_SOURCE_PERMISSIONS
        DESTINATION ${CMAKE_INSTALL_DATADIR}/codec2)
endif()

# LPCNet needs to be bootstraped because codec2 and freedvlpcnet are
# cross dependent.
option(LPCNET "Build codec2 with LPCNet support." OFF)
set(LPCNET_BUILD_DIR FALSE CACHE PATH "Location of lpcnet build tree.")
# Setting LPCNET_BUILD_DIR implies LPCNET=ON
if(LPCNET_BUILD_DIR)
    set(LPCNET ON)
endif()



include(CheckIncludeFiles)
check_include_files("stdlib.h" HAVE_STDLIB_H)
check_include_files("string.h" HAVE_STRING_H)

include(CheckSymbolExists)
# Check if _GNU_SOURCE is available.
if (NOT DEFINED _GNU_SOURCE)
  check_symbol_exists(__GNU_LIBRARY__ "features.h" _GNU_SOURCE)

  if (NOT _GNU_SOURCE)
    unset(_GNU_SOURCE CACHE)
    check_symbol_exists(_GNU_SOURCE "features.h" _GNU_SOURCE)
  endif()
endif()

if (_GNU_SOURCE)
    add_definitions(-D_GNU_SOURCE=1)
endif()

check_symbol_exists(floor  math.h   HAVE_FLOOR)
check_symbol_exists(ceil   math.h   HAVE_CEIL)
check_symbol_exists(pow    math.h   HAVE_POW)
check_symbol_exists(sqrt   math.h   HAVE_SQRT)
check_symbol_exists(sin    math.h   HAVE_SIN)
check_symbol_exists(cos    math.h   HAVE_COS)
check_symbol_exists(atan2  math.h   HAVE_ATAN2)
check_symbol_exists(log10  math.h   HAVE_LOG10)
check_symbol_exists(round  math.h   HAVE_ROUND)
check_symbol_exists(getopt getopt.h HAVE_GETOPT)

configure_file ("${PROJECT_SOURCE_DIR}/cmake/config.h.in"
                "${PROJECT_BINARY_DIR}/config.h" )
# Output path is such that #include <codec2/version.h> in codec2.h works
set(CODEC2_VERSION_PATH "${PROJECT_BINARY_DIR}/codec2")
configure_file ("${PROJECT_SOURCE_DIR}/cmake/version.h.in"
                "${CODEC2_VERSION_PATH}/version.h" )
include_directories(${PROJECT_BINARY_DIR})

# CMake Package setup
#include(CMakePackageConfigHelpers)
#configure_package_config_file(cmake/codec2-config.cmake.in
#    ${CMAKE_CURRENT_BINARY_DIR}/codec2-config.cmake
#    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/codec2
#    PATH_VARS CMAKE_INSTALL_INCLUDEDIR
#)


#
# Find lpcnet library
#
if(LPCNET)
    if(LPCNET_BUILD_DIR)
        # Theoretically this shouldn't be needed as we're also defining LPCNET_BUILD_DIR
        # in the PATHS section below. But on Fedora 37, CMake can't find LPCNet (at least
        # in Docker) without this.
        set(lpcnetfreedv_DIR ${LPCNET_BUILD_DIR})
        
        find_package(lpcnetfreedv REQUIRED
            PATHS ${LPCNET_BUILD_DIR}
            NO_DEFAULT_PATH
            CONFIGS lpcnetfreedv.cmake
        )
        if(lpcnetfreedv_FOUND)
            message(STATUS "liblpcnetfreedv found in build tree.")
            add_definitions("-D__LPCNET__")
        else()
            message(FATAL_ERROR "LPCNet include/library not found in build tree.")
        endif()
    else()
        find_package(lpcnetfreedv REQUIRED)
        if(lpcnetfreedv_FOUND)
            add_definitions("-D__LPCNET__")
            message(STATUS "liblpcnetfreedv found.")
        else()
            message(FATAL_ERROR "lpcnetfreedv library not found.")
        endif()
    endif()
endif()


#
# codec2 library and demo apps
#
add_subdirectory(src)
add_subdirectory(demo)


if(UNITTEST)
    # Pthread Library
    find_package(Threads REQUIRED)
    message(STATUS "Threads library flags: ${CMAKE_THREAD_LIBS_INIT}")

    add_subdirectory(unittest)
    add_subdirectory(misc)
endif(UNITTEST)

message(STATUS "Build type is: " ${CMAKE_BUILD_TYPE})
string(TOUPPER ${CMAKE_BUILD_TYPE} _FLAGS)
if(_FLAGS STREQUAL "NONE")
    message(STATUS "Compiler Flags: " ${CMAKE_C_FLAGS})
else()
    message(STATUS "Compiler Flags: " ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_${_FLAGS}})
endif()
message(STATUS "Libraries linked: " ${CMAKE_REQUIRED_LIBRARIES})

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Next-Generation Digital Voice for Two-Way Radio")
set(CPACK_PACKAGE_VENDOR "CMake")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR ${CODEC2_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${CODEC2_VERSION_MINOR})
if(CODEC2_VERSION_PATCH)
    set(CPACK_PACKAGE_VERSION_PATCH ${CODEC2_VERSION_PATCH})
else()
    set(CPACK_PACKAGE_VERSION_PATCH 0)
endif()

# Return the date (yyyy-mm-dd)
string(TIMESTAMP DATE_RESULT "%Y-%m-%d" UTC)
message(STATUS "Compilation date = XX${DATE_RESULT}XX")

set(CPACK_PACKAGE_VERSION_PATCH "${CPACK_PACKAGE_VERSION_PATCH}-${DATE_RESULT}-${CODEC2_HASH}")

if(WIN32)
    #
    # Cpack NSIS installer configuration for Windows.
    # See: http://nsis.sourceforge.net/Download
    #

    # Detect if we're doing a 32-bit or 64-bit windows build.
    if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
        set(CMAKE_CL_64 TRUE)
    endif()
    configure_file(cmake/GetDependencies.cmake.in cmake/GetDependencies.cmake
        @ONLY
    )
    install(SCRIPT ${CMAKE_BINARY_DIR}/cmake/GetDependencies.cmake)
    set(CPACK_PACKAGE_INSTALL_DIRECTORY "Codec2")
    set(CPACK_CREATE_DESKTOP_LINKS "")
    set(CPACK_NSIS_DISPLAY_NAME "${CPACK_PACKAGE_INSTALL_DIRECTORY}")
    set(CPACK_NSIS_URL_INFO_ABOUT "http://rowetel.com/codec2.html")
    set(CPACK_NSIS_MODIFY_PATH ON)
    include(CPack)
elseif(UNIX AND NOT APPLE)
    # Linux packaging
    SET(CPACK_GENERATOR "DEB")
    SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Mooneer Salem <mooneer@gmail.com>") #required
    SET(CPACK_DEB_COMPONENT_INSTALL ON)
    SET(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
    SET(CPACK_DEBIAN_ENABLE_COMPONENT_DEPENDS ON)
    SET(CPACK_DEBIAN_LIB_PACKAGE_NAME "codec2")
    SET(CPACK_DEBIAN_PACKAGE_DEPENDS "lpcnet (>= 0.3.0)")
    include(CPack)
    cpack_add_component(lib REQUIRED)
    cpack_add_component(dev DEPENDS lib)
endif(WIN32)

########################################################################
# Create Pkg Config File
########################################################################
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/codec2.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/codec2.pc
    @ONLY
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/codec2.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT "codec2_devel"
)

##################################################################
# Tests
##################################################################

if(UNITTEST)
    include(CTest)
    enable_testing()

    add_test(NAME test_freedv_get_hash
             COMMAND sh -c "${CMAKE_CURRENT_BINARY_DIR}/unittest/thash")

if(UNIX) # Uses pthreads
     add_test(NAME test_fifo
             COMMAND $<TARGET_FILE:tfifo>
             )
endif()

    # 16<->8 kHz float resamplers
    add_test(NAME test_fdmdv_16to8
             COMMAND sh -c "cd ${CMAKE_CURRENT_SOURCE_DIR}/octave;
                            ${CMAKE_CURRENT_BINARY_DIR}/unittest/t16_8;
                            DISPLAY=\"\" echo \"diff_fft_mag('in8.raw','out8.raw'); quit;\" | octave-cli -qf
                            ")
             set_tests_properties(test_fdmdv_16to8 PROPERTIES PASS_REGULAR_EXPRESSION "PASS")

    # 16<->8 kHz short (int16) resamplers
    add_test(NAME test_fdmdv_16to8_short
             COMMAND sh -c "cd ${CMAKE_CURRENT_SOURCE_DIR}/octave;
                            ${CMAKE_CURRENT_BINARY_DIR}/unittest/t16_8_short;
                            DISPLAY=\"\" echo \"diff_fft_mag('in8_short.raw','out8_short.raw'); quit;\" | octave-cli -qf
                            ")
             set_tests_properties(test_fdmdv_16to8_short PROPERTIES PASS_REGULAR_EXPRESSION "PASS")

    # 48<->8 kHz float resamplers
    add_test(NAME test_fdmdv_48to8_short
             COMMAND sh -c "cd ${CMAKE_CURRENT_SOURCE_DIR}/octave;
                            ${CMAKE_CURRENT_BINARY_DIR}/unittest/t48_8_short;
                            DISPLAY=\"\" echo \"diff_fft_mag('in8.raw','out8.raw'); quit;\" | octave-cli -qf
                            ")
             set_tests_properties(test_fdmdv_48to8_short PROPERTIES PASS_REGULAR_EXPRESSION "PASS")

    # 48<->8 kHz short resamplers
    add_test(NAME test_fdmdv_48to8

=== misc/CMakeLists.txt ===
add_definitions(-DFLOATING_POINT -DVAR_ARRAYS)
include_directories(../src)

add_executable(mksine mksine.c)
target_link_libraries(mksine m)

add_executable(16_8_short 16_8_short.c ../src/fdmdv.c ../src/kiss_fft.c)
target_link_libraries(16_8_short codec2)

add_executable(extract extract.c)

add_executable(vqtrain vqtrain.c)
target_link_libraries(vqtrain m)

add_executable(raw2h raw2h.c)
target_link_libraries(raw2h codec2)

add_executable(tnlp tnlp.c)
target_link_libraries(tnlp codec2)

add_executable(tlininterp tlininterp.c)

add_executable(tdec tdec.c)

add_executable(timpulse timpulse.c)
target_link_libraries(timpulse m)

add_executable(vq_mbest vq_mbest.c)
target_link_libraries(vq_mbest codec2)

add_executable(vq_binary_switch vq_binary_switch.c)
target_link_libraries(vq_binary_switch m)

add_executable(pre pre.c)
target_link_libraries(pre codec2)

=== src/CMakeLists.txt ===
#
# Generated sources
#

set(D ${CMAKE_CURRENT_SOURCE_DIR}/codebook)

# lsp quantisers (2400/1400/1300 modes)
set(CODEBOOKS
    ${D}/lsp1.txt
    ${D}/lsp2.txt
    ${D}/lsp3.txt
    ${D}/lsp4.txt
    ${D}/lsp5.txt
    ${D}/lsp6.txt
    ${D}/lsp7.txt
    ${D}/lsp8.txt
    ${D}/lsp9.txt
    ${D}/lsp10.txt
)

# lspd quantisers (3200 mode)
set(CODEBOOKSD
    ${D}/dlsp1.txt
    ${D}/dlsp2.txt
    ${D}/dlsp3.txt
    ${D}/dlsp4.txt
    ${D}/dlsp5.txt
    ${D}/dlsp6.txt
    ${D}/dlsp7.txt
    ${D}/dlsp8.txt
    ${D}/dlsp9.txt
    ${D}/dlsp10.txt
)

# LSP VQ (1200 mode)
set(CODEBOOKSJMV
    ${D}/lspjmv1.txt
    ${D}/lspjmv2.txt
    ${D}/lspjmv3.txt
)

# Joint Wo-energy VQ (1200 mode)
set(CODEBOOKSGE ${D}/gecb.txt)

# 700C two stage VQ
set(CODEBOOKSNEWAMP1
    ${D}/train_120_1.txt
    ${D}/train_120_2.txt
)

set(CODEBOOKSNEWAMP1_ENERGY
    ${D}/newamp1_energy_q.txt
)

# 450 mode two stage VQ
set(CODEBOOKSNEWAMP2
    ${D}/codes_450.txt
)

set(CODEBOOKSNEWAMP2_ENERGY
    ${D}/newamp2_energy_q.txt
)

# when crosscompiling we need a native executable
if(CMAKE_CROSSCOMPILING)
    set(CMAKE_DISABLE_SOURCE_CHANGES OFF)
    include(ExternalProject)
    ExternalProject_Add(codec2_native
       SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/..
       BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/codec2_native
       BUILD_COMMAND ${CMAKE_COMMAND} --build . --target generate_codebook
       INSTALL_COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/codec2_native/src/generate_codebook ${CMAKE_CURRENT_BINARY_DIR}
       BUILD_BYPRODUCTS ${CMAKE_CURRENT_BINARY_DIR}/generate_codebook
    )
    add_executable(generate_codebook IMPORTED)
    set_target_properties(generate_codebook PROPERTIES
        IMPORTED_LOCATION ${CMAKE_CURRENT_BINARY_DIR}/generate_codebook)
    add_dependencies(generate_codebook codec2_native)
    set(CMAKE_DISABLE_SOURCE_CHANGES ON)
else(CMAKE_CROSSCOMPILING)
# Build code generator binaries. These do not get installed.
    # generate_codebook
    add_executable(generate_codebook generate_codebook.c)
    target_link_libraries(generate_codebook m)
    # Make native builds available for cross-compiling.
    export(TARGETS generate_codebook
        FILE ${CMAKE_BINARY_DIR}/ImportExecutables.cmake)
endif(CMAKE_CROSSCOMPILING)


# codebook.c
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/codebook.c
    COMMAND generate_codebook lsp_cb ${CODEBOOKS} > ${CMAKE_CURRENT_BINARY_DIR}/codebook.c
    DEPENDS generate_codebook ${CODEBOOKS}
)

# codebookd.c
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/codebookd.c
    COMMAND generate_codebook lsp_cbd ${CODEBOOKSD} > ${CMAKE_CURRENT_BINARY_DIR}/codebookd.c
    DEPENDS generate_codebook ${CODEBOOKSD}
)

# codebookjmv.c
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/codebookjmv.c
    COMMAND generate_codebook lsp_cbjmv ${CODEBOOKSJMV} > ${CMAKE_CURRENT_BINARY_DIR}/codebookjmv.c
    DEPENDS generate_codebook ${CODEBOOKSJMV}
)

# codebookge.c
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/codebookge.c
    COMMAND generate_codebook ge_cb ${CODEBOOKSGE} > ${CMAKE_CURRENT_BINARY_DIR}/codebookge.c
    DEPENDS generate_codebook ${CODEBOOKSGE}
)

# codebooknewamp1.c
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/codebooknewamp1.c
    COMMAND generate_codebook newamp1vq_cb ${CODEBOOKSNEWAMP1} > ${CMAKE_CURRENT_BINARY_DIR}/codebooknewamp1.c
    DEPENDS generate_codebook ${CODEBOOKSNEWAMP1}
)

# codebooknewamp1_energy.c
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/codebooknewamp1_energy.c
    COMMAND generate_codebook newamp1_energy_cb ${CODEBOOKSNEWAMP1_ENERGY} > ${CMAKE_CURRENT_BINARY_DIR}/codebooknewamp1_energy.c
    DEPENDS generate_codebook ${CODEBOOKSNEWAMP1_ENERGY}
)

# codebooknewamp2.c
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/codebooknewamp2.c
    COMMAND generate_codebook newamp2vq_cb ${CODEBOOKSNEWAMP2} > ${CMAKE_CURRENT_BINARY_DIR}/codebooknewamp2.c
    DEPENDS generate_codebook ${CODEBOOKSNEWAMP2}
)

# codebooknewamp2_energy.c
add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/codebooknewamp2_energy.c
    COMMAND generate_codebook newamp2_energy_cb ${CODEBOOKSNEWAMP2_ENERGY} > ${CMAKE_CURRENT_BINARY_DIR}/codebooknewamp2_energy.c
    DEPENDS generate_codebook ${CODEBOOKSNEWAMP2_ENERGY}
)

#
# codec2 library sources
#

set(CODEC2_SRCS
    dump.c
    lpc.c
    nlp.c
    postfilter.c
    sine.c
    codec2.c
    codec2_fft.c
    cohpsk.c
    codec2_fifo.c
    fdmdv.c
    fm.c
    fsk.c
    fmfsk.c
    kiss_fft.c
    kiss_fftr.c
    linreg.c
    interp.c
    lsp.c
    mbest.c
    newamp1.c
    newamp2.c
    ofdm.c
    ofdm_mode.c
    phase.c
    quantise.c
    pack.c
    codebook.c
    codebookd.c
    codebookjmv.c
    codebookge.c
    codebooknewamp1.c
    codebooknewamp1_energy.c
    codebooknewamp2.c
    codebooknewamp2_energy.c
    golay23.c
    freedv_api.c
    freedv_1600.c
    freedv_700.c
    freedv_2020.c
    freedv_fsk.c
    freedv_vhf_framing.c
    freedv_data_channel.c
    varicode.c
    modem_stats.c
    ofdm.c
    mpdecode_core.c
    phi0.c
    gp_interleaver.c
    interldpc.c
    filter.c
    HRA_112_112.c
    HRA_56_56.c
    HRAb_396_504.c
    H_256_768_22.c
    H_256_512_4.c
    HRAa_1536_512.c
    H_128_256_5.c
    H_2064_516_sparse.c
    H_4096_8192_3d.c
    H_16200_9720.c
    H_1024_2048_4f.c
    H_212_158.c
    ldpc_codes.c
    lpcnet_freq.c
    reliable_text.c
)

set(CODEC2_PUBLIC_HEADERS
    codec2.h
    codec2_fdmdv.h
    codec2_cohpsk.h
    codec2_fm.h
    codec2_ofdm.h
    fsk.h
    codec2_fifo.h
    comp.h
    modem_stats.h
    freedv_api.h
    reliable_text.h
    codec2_math.h
    ${CODEC2_VERSION_PATH}/version.h
)

#
# Debug options
#
#add_definitions(-DDEBUG_ALLOC)

#
# Setup the codec2 library
#
# Patch level version bumps should not change API/ABI.
set(SOVERSION "${CODEC2_VERSION_MAJOR}.${CODEC2_VERSION_MINOR}")
message(STATUS "codec2 version: ${CODEC2_VERSION}")
add_library(codec2 ${CODEC2_SRCS})
if(UNIX)
    target_link_libraries(codec2 PUBLIC m)
endif(UNIX)
if(LPCNET AND lpcnetfreedv_FOUND)
    target_link_libraries(codec2 PRIVATE lpcnetfreedv)
endif()
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
set_target_properties(codec2 PROPERTIES
    SOVERSION ${SOVERSION}
    PUBLIC_HEADER "${CODEC2_PUBLIC_HEADERS}"
)

# Required include directories for export
target_include_directories(codec2 INTERFACE
    $<INSTALL_INTERFACE:include/codec2>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}>
)

# Export config for import from full install
install(EXPORT codec2-config
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/codec2
)

# Export config for import from build tree.
export(TARGETS codec2
    FILE ${CMAKE_BINARY_DIR}/codec2.cmake
)

add_executable(c2enc c2enc.c)
target_link_libraries(c2enc codec2)

add_executable(c2dec c2dec.c)
target_link_libraries(c2dec codec2)

add_executable(c2sim c2sim.c sd.c)
target_link_libraries(c2sim codec2)

add_executable(fdmdv_get_test_bits fdmdv_get_test_bits.c fdmdv.c kiss_fft.c codec2_fft.c kiss_fftr.c)
target_link_libraries(fdmdv_get_test_bits m)

add_executable(fdmdv_mod fdmdv_mod.c fdmdv.c kiss_fft.c codec2_fft.c kiss_fftr.c)
target_link_libraries(fdmdv_mod m)

add_executable(fdmdv_demod fdmdv_demod.c fdmdv.c kiss_fft.c octave.c modem_stats.c codec2_fft.c kiss_fftr.c)
target_link_libraries(fdmdv_demod m)

add_executable(fdmdv_put_test_bits fdmdv_put_test_bits.c fdmdv.c kiss_fft.c codec2_fft.c kiss_fftr.c)
target_link_libraries(fdmdv_put_test_bits m)

add_executable(freedv_tx freedv_tx.c)
target_link_libraries(freedv_tx codec2)

add_executable(freedv_rx freedv_rx.c)
target_link_libraries(freedv_rx codec2)

add_executable(freedv_data_raw_tx freedv_data_raw_tx.c)
target_link_libraries(freedv_data_raw_tx codec2)

add_executable(freedv_data_raw_rx freedv_data_raw_rx.c octave.c)
target_link_libraries(freedv_data_raw_rx codec2)

add_executable(freedv_data_tx freedv_data_tx.c)
target_link_libraries(freedv_data_tx codec2)

add_executable(freedv_data_rx freedv_data_rx.c)
target_link_libraries(freedv_data_rx codec2)

add_executable(freedv_mixed_tx freedv_mixed_tx.c)
target_link_libraries(freedv_mixed_tx codec2)

add_executable(freedv_mixed_rx freedv_mixed_rx.c)
target_link_libraries(freedv_mixed_rx codec2)

add_executable(fsk_mod fsk_mod.c)
target_link_libraries(fsk_mod codec2)

add_executable(fsk_mod_ext_vco fsk_mod_ext_vco.c)
target_link_libraries(fsk_mod_ext_vco m)

add_executable(fsk_demod fsk_demod.c modem_probe.c octave.c)
target_link_libraries(fsk_demod codec2)

add_executable(fsk_get_test_bits fsk_get_test_bits.c)
target_link_libraries(fsk_get_test_bits)

add_executable(fsk_put_test_bits fsk_put_test_bits.c)
target_link_libraries(fsk_put_test_bits codec2)

add_executable(framer framer.c)
target_link_libraries(framer)

add_executable(deframer deframer.c)
target_link_libraries(deframer)

add_executable(fm_demod fm_demod.c fm.c)
target_link_libraries(fm_demod m)

add_executable(cohpsk_mod cohpsk_mod.c)
target_link_libraries(cohpsk_mod codec2)

add_executable(ofdm_get_test_bits ofdm_get_test_bits.c)
target_link_libraries(ofdm_get_test_bits codec2)

add_executable(ofdm_put_test_bits ofdm_put_test_bits.c)
target_link_libraries(ofdm_put_test_bits codec2)

add_executable(ofdm_mod ofdm_mod.c)
target_link_libraries(ofdm_mod codec2)

add_executable(ofdm_demod ofdm_demod.c octave.c)
target_link_libraries(ofdm_demod codec2)

add_executable(fmfsk_mod fmfsk_mod.c)
target_link_libraries(fmfsk_mod codec2)

add_executable(fmfsk_demod fmfsk_demod.c modem_probe.c octave.c)
target_link_libraries(fmfsk_demod codec2)

add_executable(vhf_deframe_c2 vhf_deframe_c2.c)
target_link_libraries(vhf_deframe_c2  codec2)

add_executable(vhf_frame_c2 vhf_frame_c2.c)
target_link_libraries(vhf_frame_c2  codec2)

add_executable(cohpsk_demod cohpsk_demod.c octave.c)
target_link_libraries(cohpsk_demod codec2)

add_executable(cohpsk_get_test_bits cohpsk_get_test_bits.c)
target_link_libraries(cohpsk_get_test_bits codec2)

add_executable(cohpsk_put_test_bits cohpsk_put_test_bits.c octave.c)
target_link_libraries(cohpsk_put_test_bits codec2)

add_executable(ch ch.c)
target_link_libraries(ch codec2)

add_executable(tollr tollr.c)

add_executable(ldpc_noise ldpc_noise.c)
target_link_libraries(ldpc_noise m)

add_executable(ldpc_enc ldpc_enc.c)
target_link_libraries(ldpc_enc codec2)

add_executable(ldpc_dec ldpc_dec.c)
target_link_libraries(ldpc_dec codec2)

install(TARGETS codec2 EXPORT codec2-config
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT lib
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT lib
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/codec2 COMPONENT dev
)

=== unittest/CMakeLists.txt ===
add_definitions(-DFLOATING_POINT -DVAR_ARRAYS)
include_directories(../src)

add_executable(tfdmdv tfdmdv.c ../src/fdmdv.c ../src/kiss_fft.c ../src/octave.c)
target_link_libraries(tfdmdv codec2)

add_executable(tcohpsk tcohpsk.c ../src/cohpsk.c ../src/octave.c)
target_link_libraries(tcohpsk codec2)

add_executable(tfsk tfsk.c ../src/kiss_fft.c ../src/kiss_fftr.c ../src/octave.c ../src/modem_probe.c)
target_link_libraries(tfsk m)

add_executable(tfreedv_data_channel tfreedv_data_channel.c ../src/freedv_data_channel.c)

add_executable(tfmfsk tfmfsk.c ../src/octave.c ../src/modem_probe.c)
target_link_libraries(tfmfsk m)

add_executable(tdeframer tdeframer.c)
target_link_libraries(tdeframer m codec2)

add_definitions(-DMODEMPROBE_ENABLE -DXXXXX)

add_executable(tofdm tofdm.c ../src/octave.c)
target_link_libraries(tofdm m codec2)

add_executable(tofdm_acq tofdm_acq.c ../src/octave.c)
target_link_libraries(tofdm_acq m codec2)

add_executable(tesno_est tesno_est.c)
target_link_libraries(tesno_est m codec2)

if(UNIX) # Uses pthreads
add_executable(tfifo tfifo.c ../src/codec2_fifo.c)
target_link_libraries(tfifo codec2 ${CMAKE_THREAD_LIBS_INIT})
endif()

add_executable(fdmdv_mem fdmdv_mem.c)

add_executable(ofdm_mem ofdm_mem.c ../src/ofdm.c ../src/octave.c ../src/kiss_fft.c ../src/modem_probe.c ../src/mpdecode_core.c ../src/phi0.c ../src/filter.c)
target_link_libraries(ofdm_mem m)

add_library(function_trace STATIC ../unittest/function_trace.c)

add_executable(ofdm_stack ofdm_stack.c ../src/ofdm.c ../src/octave.c ../src/kiss_fft.c ../src/modem_probe.c ../src/mpdecode_core.c ../src/phi0.c ../src/filter.c)
if (CMAKE_C_COMPILER MATCHES "gcc$")
    target_link_libraries(ofdm_stack function_trace m -no-pie "-Wl,-Map=ofdm_stack.map")
    target_compile_options(ofdm_stack PUBLIC -fstack-usage -finstrument-functions)
else()
    target_link_libraries(ofdm_stack function_trace m -no-pie)
    target_compile_options(ofdm_stack PUBLIC -finstrument-functions)
endif()
add_definitions(-D__UNITTEST__)

add_executable(tnewamp1 tnewamp1.c ../src/quantise.c ../src/newamp1.c ../src/mbest.c ../src/kiss_fft.c ../src/sine.c ../src/nlp.c ../src/dump.c ../src/octave.c ${CODEBOOKS})
target_link_libraries(tnewamp1 codec2)

add_executable(compare_ints compare_ints.c)

add_executable(compare_floats compare_floats.c)

add_executable(test_phi0 test_phi0.c ../src/phi0.c)
target_link_libraries(test_phi0 m)

add_executable(tst_codec2_fft_init tst_codec2_fft_init.c)
target_link_libraries(tst_codec2_fft_init m codec2)

add_executable(tvq_mbest tvq_mbest.c)

add_executable(tfreedv_800XA_rawdata tfreedv_800XA_rawdata.c)
target_link_libraries(tfreedv_800XA_rawdata codec2)

add_executable(tfreedv_2400A_rawdata tfreedv_2400A_rawdata.c)
target_link_libraries(tfreedv_2400A_rawdata codec2)

add_executable(tfreedv_2400B_rawdata tfreedv_2400B_rawdata.c)
target_link_libraries(tfreedv_2400B_rawdata codec2)

add_executable(tfsk_llr tfsk_llr.c)
target_link_libraries(tfsk_llr codec2 m)

add_executable(thash thash.c)
target_link_libraries(thash codec2 m)

add_executable(tqam16 tqam16.c)
target_link_libraries(tqam16 codec2 m)

add_executable(t16_8 t16_8.c ../src/fdmdv.c ../src/kiss_fft.c)
target_link_libraries(t16_8 codec2)

add_executable(t16_8_short t16_8_short.c ../src/fdmdv.c ../src/kiss_fft.c)
target_link_libraries(t16_8_short codec2)

add_executable(t48_8 t48_8.c ../src/fdmdv.c ../src/kiss_fft.c)
target_link_libraries(t48_8 codec2)

add_executable(t48_8_short t48_8_short.c ../src/fdmdv.c ../src/kiss_fft.c)
target_link_libraries(t48_8_short codec2)

add_executable(tquisk_filter tquisk_filter.c)
target_link_libraries(tquisk_filter codec2)

# Build CML as part of unit test setup
find_program(OCTAVE_CMD octave-cli REQUIRED)
message("Octave command: ${OCTAVE_CMD}")

include(ExternalProject)
set(CML_PATH ${CMAKE_CURRENT_BINARY_DIR}/../cml)
ExternalProject_Add(cml
   GIT_REPOSITORY https://github.com/drowe67/cml.git
   SOURCE_DIR ${CML_PATH}
   BUILD_IN_SOURCE 1
   CONFIGURE_COMMAND true # No configuration required
   BUILD_COMMAND cd ${CMAKE_CURRENT_BINARY_DIR}/../cml && make
   INSTALL_COMMAND true # No installation required
)

# Create fading files (used for channel simulation) as part of unit test setup
add_custom_target(fading_files ALL
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/fast_fading_samples.float
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/faster_fading_samples.float
  )
add_custom_command(
  OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/fast_fading_samples.float
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/faster_fading_samples.float
  COMMAND cd ${CMAKE_CURRENT_SOURCE_DIR} && ./fading_files.sh ${CMAKE_CURRENT_BINARY_DIR}
)

add_executable(freedv_700d_comptx freedv_700d_comptx.c)
add_executable(freedv_700d_comprx freedv_700d_comprx.c)

if(LPCNET AND lpcnetfreedv_FOUND)
    target_link_libraries(freedv_700d_comptx m codec2 lpcnetfreedv)
    target_link_libraries(freedv_700d_comprx m codec2 lpcnetfreedv)
else()
    target_link_libraries(freedv_700d_comptx m codec2)
    target_link_libraries(freedv_700d_comprx m codec2)
endif()

add_executable(golay23 ../src/golay23.c)
target_compile_options(golay23 PUBLIC -DGOLAY23_UNITTEST)

add_executable(golay23_runtime_tables ../src/golay23.c)
target_compile_options(golay23_runtime_tables PUBLIC -DGOLAY23_UNITTEST -DRUN_TIME_TABLES)

=== unittest/raw_data_curves/Makefile ===
# Makefile
# Dec 2022
#
# Automates PER/BER curve generation for raw data mode:
#
# 1. Compare "ch" noise injection/SNR measurement against reference Octave Tx
# 2. Compare C Tx against Octave Tx (with and without compression)
# 3. Plot curves for SNR estimated from C Rx against actual SNR
# 4. Plot AWGN/PER C Tx curves for end user documentation

SHELL  := /bin/bash
CODEC2 := $(HOME)/codec2

all: test \
     octave_ch_noise_awgn.png octave_c_tx_awgn.png octave_c_tx_comp_awgn.png \
     octave_ch_noise_mpp.png octave_c_tx_mpp.png octave_c_tx_comp_mpp.png \
     snrest_snr_ctx.png snrest_snr_ctxc.png \
     c_tx_comp.png c_tx_comp_thruput.png

clean:
	rm -f *.txt *.png *.raw

# run this first, traps common CML setup error
test:
	source snr_curves.sh; test_ldpc

# subset of files generated, but enough to set up Makefile dependencies
snr_oct =  snr_oct_datac0_awgn.txt  snr_oct_datac1_awgn.txt  snr_oct_datac3_awgn.txt
snr_ch  =  snr_ch_datac0_awgn.txt   snr_ch_datac1_awgn.txt   snr_ch_datac3_awgn.txt
snr_ctx =  snr_ctx_datac0_awgn.txt  snr_ctx_datac1_awgn.txt  snr_ctx_datac3_awgn.txt
snr_ctxc = snr_ctxc_datac0_awgn.txt snr_ctxc_datac3_awgn.txt

snr_oct_mpp  = snr_oct_datac0_mpp.txt  snr_oct_datac1_mpp.txt  snr_oct_datac3_mpp.txt
snr_ch_mpp   = snr_ch_datac0_mpp.txt   snr_ch_datac1_mpp.txt   snr_ch_datac3_mpp.txt
snr_ctx_mpp  = snr_ctx_datac0_mpp.txt  snr_ctx_datac1_mpp.txt  snr_ctx_datac3_mpp.txt
snr_ctxc_mpp = snr_ctxc_datac0_mpp.txt snr_ctxc_datac3_mpp.txt

$(snr_oct):
	source snr_curves.sh; generate_octave_tx_data datac0 awgn
	source snr_curves.sh; generate_octave_tx_data datac1 awgn
	source snr_curves.sh; generate_octave_tx_data datac3 awgn

$(snr_oct_mpp):
	source snr_curves.sh; generate_octave_tx_data datac0 mpp
	source snr_curves.sh; generate_octave_tx_data datac1 mpp
	source snr_curves.sh; generate_octave_tx_data datac3 mpp

$(snr_ch):
	source snr_curves.sh; generate_ch_data datac0 awgn
	source snr_curves.sh; generate_ch_data datac1 awgn
	source snr_curves.sh; generate_ch_data datac3 awgn

$(snr_ch_mpp):
	source snr_curves.sh; generate_ch_data datac0 mpp
	source snr_curves.sh; generate_ch_data datac1 mpp
	source snr_curves.sh; generate_ch_data datac3 mpp

# C without compression

$(snr_ctx):
	source snr_curves.sh; generate_snrest_v_snr_data datac0 awgn
	source snr_curves.sh; generate_snrest_v_snr_data datac1 awgn
	source snr_curves.sh; generate_snrest_v_snr_data datac3 awgn
	source snr_curves.sh; generate_snrest_v_snr_data datac4 awgn
	source snr_curves.sh; generate_snrest_v_snr_data datac13 awgn

$(snr_ctx_mpp):
	source snr_curves.sh; generate_snrest_v_snr_data datac0 mpp
	source snr_curves.sh; generate_snrest_v_snr_data datac1 mpp
	source snr_curves.sh; generate_snrest_v_snr_data datac3 mpp
	source snr_curves.sh; generate_snrest_v_snr_data datac4 mpp
	source snr_curves.sh; generate_snrest_v_snr_data datac13 mpp

# C with compression

$(snr_ctxc):
	source snr_curves.sh; generate_snrest_v_snr_data datac0 awgn 1
	source snr_curves.sh; generate_snrest_v_snr_data datac1 awgn 1
	source snr_curves.sh; generate_snrest_v_snr_data datac3 awgn 1
	source snr_curves.sh; generate_snrest_v_snr_data datac4 awgn 1
	source snr_curves.sh; generate_snrest_v_snr_data datac13 awgn 1

$(snr_ctxc_mpp):
	source snr_curves.sh; generate_snrest_v_snr_data datac0 mpp 1
	source snr_curves.sh; generate_snrest_v_snr_data datac1 mpp 1
	source snr_curves.sh; generate_snrest_v_snr_data datac3 mpp 1
	source snr_curves.sh; generate_snrest_v_snr_data datac4 mpp 1
	source snr_curves.sh; generate_snrest_v_snr_data datac13 mpp 1

# Octave and C curves should be on top of each other, indicating Octave
# and ch noise injection/SNR measurement are equivalent
octave_ch_noise_awgn.png: $(snr_oct) $(snr_ch)
	echo "snr_curves_plot; octave_ch_noise_print('awgn'); quit" | \
        octave-cli -p $(CODEC2)/octave
octave_ch_noise_mpp.png: $(snr_oct_mpp) $(snr_ch_mpp)
	echo "snr_curves_plot; octave_ch_noise_print('mpp'); quit" | \
        octave-cli -p $(CODEC2)/octave

# Octave Tx and C Tx curves should be on top of each other
octave_c_tx_awgn.png: $(snr_oct) $(snr_ctx)
	echo "snr_curves_plot; octave_c_tx_print('awgn'); quit" | \
        octave-cli -p $(CODEC2)/octave
octave_c_tx_mpp.png: $(snr_oct_mpp) $(snr_ctx_mpp)
	echo "snr_curves_plot; octave_c_tx_print('mpp'); quit" | \
        octave-cli -p $(CODEC2)/octave

# Octave Tx and C Tx (compressed) curves should be close, but C may be 1dB
# poorer
octave_c_tx_comp_awgn.png: $(snr_oc) $(snr_ctxc)
	echo "snr_curves_plot; octave_c_tx_comp_print('awgn'); quit" | \
        octave-cli -p $(CODEC2)/octave
octave_c_tx_comp_mpp.png: $(snr_oct_mpp) $(snr_ctxc_mpp)
	echo "snr_curves_plot; octave_c_tx_comp_print('mpp'); quit" | \
        octave-cli -p $(CODEC2)/octave

# combined AWGN and MPP from C Tx (compressed) - what end users would run
c_tx_comp.png: $(snr_ctxc) $(snr_ctxc_mpp)
	echo "snr_curves_plot; c_tx_comp_print; quit" | \
        octave-cli -p $(CODEC2)/octave

# Curves of SNR estimates from C Rx compared to actual SNR, useful for "gear shifting"
snrest_snr_ctx.png: $(snr_ctx)
	echo "snr_curves_plot; snrest_snr_print('ctx', 'awgn'); quit" | \
        octave-cli -p $(CODEC2)/octave
snrest_snr_ctxc.png: $(snr_ctxc)
	echo "snr_curves_plot; snrest_snr_print('ctxc', 'awgn'); quit" | \
        octave-cli -p $(CODEC2)/octave

# Throughput of payload data in bits/s of modes against SNR
c_tx_comp_thruput.png: $(snr_ctxc) $(snr_ctxc_mpp)
	echo "snr_curves_plot; c_tx_comp_thruput_print; quit" | \
        octave-cli -p $(CODEC2)/octave

=== debian/changelog ===
codec2 (1.1.1-5ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Disable unittests (needing octave) on i386
    - Don't build-depend on octave on i386.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Jul 2023 08:58:26 +0200

codec2 (1.1.1-5) unstable; urgency=medium

  * Apply hints suggested by the multi-arch hinter.
    codec2-examples: Add :any qualifier for python3 dependency
    libcodec2-dev: Add Multi-Arch: same
    (Janitor)
  * Support nocheck option (Closes: #1021363)
    to reduce the amount of absolutely required Build-Depends
    (Paul Gevers)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 15 Jul 2023 20:59:32 -0400

codec2 (1.1.1-4) experimental; urgency=medium

  * provide for no available optimizations when testing
    lpcnet/src/test_vec.c rather than failing to compile.

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 15 Jul 2023 19:37:34 -0400

codec2 (1.1.1-3) experimental; urgency=medium

  * fix CMake systex in lpcnet-check-c-compiler-flag patch

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 15 Jul 2023 16:32:20 -0400

codec2 (1.1.1-2) experimental; urgency=medium

  * Add lpcnet-check-c-compiler-flag patch, test Debian builds in experimental

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 15 Jul 2023 13:53:45 -0400

codec2 (1.1.1-1) experimental; urgency=medium

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 10 Jul 2023 21:26:57 -0400

codec2 (1.1.0-1) experimental; urgency=medium

  * New upstream release.

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 12 May 2023 00:05:57 +0000

codec2 (1.0.5-1ubuntu2) kinetic; urgency=medium

  * Disable unittests (needing octave) on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 19 Jul 2022 09:51:49 +0200

codec2 (1.0.5-1ubuntu1) kinetic; urgency=medium

  * Don't build-depend on octave on i386.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Jul 2022 04:26:50 +0000

=== debian/control ===
Source: codec2
Section: sound
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake, debhelper-compat (= 13), libsamplerate0-dev, libspeexdsp-dev, octave [!i386] <!nocheck>, octave-dev [!i486] <!nocheck>, octave-signal [!i386] <!nocheck>, gnuplot-nox <!nocheck>, sox <!nocheck>
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://rowetel.com/codec2.html
Vcs-Browser: https://salsa.debian.org/bottoms/pkg-codec2
Vcs-Git: https://salsa.debian.org/bottoms/pkg-codec2.git

Package: codec2
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: command line tools for handling Codec2 data
 Codec2 is an audio codec especially designed for compressing voice at
 very low bit-rates for applications such as digital voice radio.
 .
 This package contains the encoder and decoder command-line applications.

Package: codec2-examples
Architecture: all
Depends: ${misc:Depends}, python3:any
Suggests: octave
Description: Codec2 sample data and examples
 Codec2 is an audio codec especially designed for compressing voice at
 very low bit-rates for applications such as digital voice radio.
 .
 This package contains sample data and supporting examples.

Package: libcodec2-1.1
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Codec2 runtime library
 Next-Generation Digital Voice for Two-Way Radio
 .
 Codec2 is an audio codec especially designed for compressing voice at
 very low bit-rates for applications such as digital voice radio.
 .
 This package contains the codec2 runtime library.

Package: libcodec2-dev
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libcodec2-1.1 (= ${binary:Version}), ${misc:Depends}
Suggests: pkg-config
Multi-Arch: same
Description: Codec2 library development files
 Codec2 is an audio codec especially designed for compressing voice at
 very low bit-rates for applications such as digital voice radio.
 .
 This package provides the codec2 library headers and development files.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  RUN_UNITTEST := TRUE
else
  RUN_UNITTEST := FALSE
endif

ifeq ($(DEB_HOST_ARCH),i386)
  RUN_UNITTEST := FALSE
endif

%:
	dh $@ --builddirectory=Build --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --builddirectory=Build/lpcnet-build --sourcedirectory=lpcnet -- \
	-DCMAKE_VERBOSE_MAKEFILE=ON -DDISABLE_CPU_OPTIMIZATION=ON \
	-DLPCNET_191005_DIR=$(CURDIR)/lpcnet191005
	cmake --build Build/lpcnet-build
	dh_auto_configure --builddirectory=Build -- \
	-DLPCNET_BUILD_DIR=$(CURDIR)/Build/lpcnet-build \
	-DBUILD_STATIC_LIBS=ON \
	-DINSTALL_EXAMPLES=TRUE \
	-DUNITTEST=$(RUN_UNITTEST) \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo
	dh_auto_configure --buildsystem=makefile \
	--builddirectory=$(CURDIR)/Build/cml-build --sourcedirectory=$(CURDIR)/cml

override_dh_auto_build:
	echo "lpcnet-build"
	cmake --build Build/lpcnet-build
	echo "codec2 build to use lpcnet"
	cmake --build Build

# Some tests are known to fail while building packages:
# - not using resource-intensive valgrind for leakage tests
# - some octave based tests fail without a full graphical environment
override_dh_auto_test:
	- export CML_PATH=$(CURDIR)/cml ; dh_auto_test

override_dh_auto_install:
	dh_auto_install
	# the test builds some test artifacts we don't want to ship
	find $(CURDIR)/debian/tmp/usr/share/codec2/octave \
		-name "*_out.txt" -delete -o -name "*.raw" -delete -o \
		-name "*.iqfloat" -delete -o -name "*vec" -delete -o \
		-name "*_log.txt" -delete
